/* VPlayer Shockwave Test Program
 * Declare Of User Main
 * 2015/5/3 clonne
 * 
 * The Declare for Main in Super Shockwave
 */

#ifndef UI_MAIN_H
#define UI_MAIN_H

#include "../shockwave/interface.h"
#include <string.h>

namespace ssw
{
    class UIMain : public CDialogImpl<UIMain>
    {
    public:
        enum {IDD = IDD_MAIN};

        BEGIN_MSG_MAP_EX(UIMain)
            COMMAND_ID_HANDLER_EX(IDC_START, OnStart)
            COMMAND_ID_HANDLER_EX(IDC_STOP, OnStop)
            COMMAND_ID_HANDLER_EX(IDC_ABOUT, OnAbout)
            MESSAGE_HANDLER(WM_NOTIFY, OnNotify)
            MSG_WM_PAINT(OnPaint)
            MSG_WM_INITDIALOG(OnInitDialog)
            MSG_WM_CLOSE(OnClose)
        END_MSG_MAP()

        enum
        {
            START,
            STOP
        }SSW_STATE;

        void OnStart(int code, int id, HWND hWnd)
        {
            if (m_Shockwave->Start())
                {
                // ״̬
                SSW_STATE = START;
                RedrawWindow();
                //
                m_btnStart.EnableWindow(FALSE);
                m_btnStop.EnableWindow(TRUE);
                }
            return;
        }

        void OnStop(int code, int id, HWND hWnd)
        {
            if (m_Shockwave->Stop())
                {
                // ״̬
                SSW_STATE = STOP;
                RedrawWindow();
                //
                m_btnStart.EnableWindow(TRUE);
                m_btnStop.EnableWindow(FALSE);
                }
            return;
        }

        void OnAbout(int code, int id, HWND hWnd)
        {
            UIAbout about;
            about.DoModal();
            return;
        }

        LRESULT OnNotify(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& HADNLER)
        {
            LPNMHDR lpnmh = (LPNMHDR) lParam;
            long sid_i;
            wchar_t *unit_str;
            
            HADNLER = TRUE;
            if (IDC_SID_P1 == lpnmh->idFrom) {sid_i = 0; unit_str = TEXT("MHz");}
            else if (IDC_SID_P2 == lpnmh->idFrom) {sid_i = 1; unit_str = TEXT("m");}
            else if (IDC_SID_P3 == lpnmh->idFrom) {sid_i = 2; unit_str = TEXT("ms");}
            else if (IDC_SID_P4 == lpnmh->idFrom) {sid_i = 3; unit_str = TEXT("m");}
            else if (IDC_SID_P5 == lpnmh->idFrom) {sid_i = 4; unit_str = TEXT("ms");}
            else return TRUE;

            if (NM_CUSTOMDRAW == lpnmh->code)
                {
                long sel_val = (long)m_sidParameter[sid_i].GetPos();
                wchar_t p_text[64];
                wsprintf(p_text, TEXT("%ld%s"), sel_val, unit_str);
                m_lbParameter[sid_i].SetWindowTextW(p_text);
                double *p_val = (double *)m_ParameterClass->p_class[sid_i].value;
                *p_val = sel_val;
                }
            return TRUE;
        }

        void OnPaint(HDC hdc)
        {   
            HPEN status_pen = CreatePen(PS_NULL, 0, 0);
            HBRUSH status_brush;
            if (START == SSW_STATE)
                status_brush = CreateSolidBrush(0x00FF00);
            else
                status_brush = CreateSolidBrush(0x0000FF);
            PAINTSTRUCT ps;

            hdc = BeginPaint(&ps);
            SelectObject(hdc, status_pen);
            SelectObject(hdc, status_brush);
            Ellipse(hdc, 15, 15, 40, 40);
            EndPaint(&ps);
            
            DeleteObject(status_brush);
            DeleteObject(status_pen);
            return;
        }

        void SelectShockwave(ulong index)
        {
            m_cbxSSW.SetCurSel(0);
            m_Shockwave = ShockwaveGet(0);
            m_ParameterClass = m_Shockwave->ParameterClass();
            PARAMETER *pl =m_ParameterClass->p_class;
            double p_val[5];
            for (ulong loop = 0; loop < m_ParameterClass->count; loop++)
                {
                p_val[loop] = *(double *)(pl[loop].value);
                // Χ
                if (pl[loop].range_set)
                    {
                    double min = *(double *)(pl[loop].range_min);
                    double max = *(double *)(pl[loop].range_max);
                    m_sidParameter[loop].SetRange((int)min, (int)max);
                    m_sidParameter[loop].SetPageSize(1);
                    }
                // Ĭֵ
                m_sidParameter[loop].SetPos((int)p_val[loop]);
                }
            return;
        }

        LRESULT OnInitDialog(HWND hWnd, LPARAM lParam)
        {
            HICON icon = LoadIcon(_AtlBaseModule.GetModuleInstance(), MAKEINTRESOURCE(IDI_ICON1));
            SetIcon(icon);
            //
            m_cbxSSW.SubclassWindow(GetDlgItem(IDC_SSW));
            m_btnStart.SubclassWindow(GetDlgItem(IDC_START));
            m_btnStop.SubclassWindow(GetDlgItem(IDC_STOP));
            m_sidParameter[0].SubclassWindow(GetDlgItem(IDC_SID_P1));
            m_sidParameter[1].SubclassWindow(GetDlgItem(IDC_SID_P2));
            m_sidParameter[2].SubclassWindow(GetDlgItem(IDC_SID_P3));
            m_sidParameter[3].SubclassWindow(GetDlgItem(IDC_SID_P4));
            m_sidParameter[4].SubclassWindow(GetDlgItem(IDC_SID_P5));
            m_lbParameter[0].SubclassWindow(GetDlgItem(IDC_LB_P1));
            m_lbParameter[1].SubclassWindow(GetDlgItem(IDC_LB_P2));
            m_lbParameter[2].SubclassWindow(GetDlgItem(IDC_LB_P3));
            m_lbParameter[3].SubclassWindow(GetDlgItem(IDC_LB_P4));
            m_lbParameter[4].SubclassWindow(GetDlgItem(IDC_LB_P5));
            //
            ulong sw_count = ShockwaveCount();
            for (ulong loop = 0; loop < sw_count; loop++)
                {
                wchar_t *sw_name = ShockwaveName(loop);
                if (NULL != sw_name)
                    m_cbxSSW.AddString(sw_name);
                }
            if (sw_count > 0)
                {
                SelectShockwave(0);
                }
            OnStop(0, 0, 0);
            return TRUE;
        }

        void OnClose()
        {
            if (NULL != m_Shockwave) delete m_Shockwave;
            EndDialog(IDCANCEL);
            return;
        }
    private:
        IShockwave      *m_Shockwave;
        PARAMETER_CLASS *m_ParameterClass;
        UISliderImpl    m_sidParameter[5];
        UILabelImpl     m_lbParameter[5];
        UIComboBoxImpl  m_cbxSSW;
        UIButtonImpl    m_btnStart;
        UIButtonImpl    m_btnStop;
    };
}

#endif
